property saveList, memRect, boxRect, targetRect, posH, posV, scale, originalWidth, originalHeight, width, height, diffWidth, diffHeight, alterH, alterV, rescaledRect, filterView, ang, distance, TargetRadius, mode, xtrawidth, boxSp, firstBitSp, maxBitSp, lastHeighBit, firstvectSp, maxVectsp, lastHeighVec, targetSp, MouseSp, memberName
global world, vitualObj

on new me, aList
  me.memberName = "viewParent"
  xtrawidth = 100
  saveList = [#posH, #posV, #scale]
  if listp(aList) then
    posH = getaProp(aList, #posH)
    posV = getaProp(aList, #posV)
    scale = getaProp(aList, #scale)
  else
    scale = 1.0
    posH = 1000
    posV = 1000
  end if
  filterView = 5
  alterH = 1
  alterV = 1
  boxSp = 1
  stagecenter = point((the stage).rect.height / 2, (the stage).rect.width / 2)
  firstvectSp = 3
  maxVectsp = firstvectSp + 40
  repeat with x = firstvectSp to maxVectsp
    set the member of sprite x to member("blankVect")
    set the loc of sprite x to point(-1000, -1000)
  end repeat
  firstBitSp = maxVectsp + 1
  maxBitSp = firstBitSp + 40
  targetSp = 120
  MouseSp = 109
  originalWidth = the width of sprite 1
  originalHeight = the height of sprite 1
  width = originalWidth * scale
  height = originalHeight * scale
  memRect = rect(0, 0, originalWidth, originalHeight)
  set the rect of sprite 1 to memRect
  TargetRadius = originalHeight / 10 * 3
  targetRect = memRect
  rescaledRect = targetRect * scale
  mode = #edit
  return me
end

on centerOBj me, obj
  offHc = getrect(me).width / 2
  offVc = getrect(me).height / 2
  toH = obj.posH - offHc
  toV = obj.posV - offVc
  jumpView2(me, posH, posV, toH, toV)
end

on jumpView2 me, fromH, fromV, toH, toV
  offH = toH - fromH
  offV = toV - fromV
  me.alterH = me.alterH + offH
  me.alterV = me.alterV + offV
end

on checkMode me, mouseObj
  a = getcenterPoint(me)
  b = point(mouseObj.posH, mouseObj.posV)
  ang = findAngle(a.locH, a.locV, b.locH, b.locV)
  distance = getDistNum(b.locH, b.locV, a.locH, a.locV)
  if me.distance > (TargetRadius * scale) then
    mode = #scroll
  else
    mode = #edit
  end if
end

on update me, mouseObj
  posH = posH + alterH
  posV = posV + alterV
  alterH = 0
  alterV = 0
  case mode of
    #scroll:
      speed = 4
      tempdist = distance - (TargetRadius * scale)
      movePoint = findMotion(ang, tempdist / speed, tempdist / speed)
      tempH = posH + getAt(movePoint, 1)
      tempV = posV + getAt(movePoint, 2)
      posH = tempH
      posV = tempV
  end case
  if intersect(rescaledRect, rect(0, 0, world.worldSizeH, world.worldSizeV)) <> rect(0, 0, world.worldSizeH, world.worldSizeV) then
    set the rect of sprite 2 to offset(rect(0, 0, world.worldSizeH, world.worldSizeV), -posH, -posV) / scale
  end if
end

on changeScale me, num, mouseObj
  if num = #reset then
    scale = 1.0
  else
    if (scale + num) < 1.0 then
      scale = 1.0
      num = 0
    end if
    if (scale + num) > 8 then
      scale = 8
      num = 0
      return 
    end if
    scale = scale + num
  end if
  tWidth = originalWidth * scale
  tHeight = originalHeight * scale
  diffWidth = (width - tWidth) / 2.0
  diffHeight = (height - tHeight) / 2.0
  width = tWidth
  height = tHeight
  posH = posH + diffWidth
  posV = posV + diffHeight
  rescaledRect = targetRect * scale
  changeScale(mouseObj, me)
  case integer(scale) of
    1:
      filterView = 5
    2:
      filterView = 4
    3:
      filterView = 3
    4:
      filterView = 2
    5:
      filterView = 1
    6:
      filterView = 0
  end case
end

on buildViewList me
  tempList = getContece(vitualObj, inflate(offset(memRect * scale, posH, posV), xtrawidth, xtrawidth), filterView)
  return tempList
end

on draw me, aList, mouseObj
  spBit = firstBitSp
  spVec = firstvectSp
  drawBox(me, targetSp, scale, posH, posV)
  draw(mouseObj, MouseSp, scale, posH, posV)
  repeat with num = count(aList) down to 1
    obj = getAt(aList, num)
    if obj.type = #bitmap then
      if spBit >= maxBitSp then
        lastHeighBit = maxBitSp
        exit repeat
      end if
      spBit = draw(obj, spBit, scale, posH, posV)
      next repeat
    end if
    if spVec >= maxVectsp then
      lastHeighVec = maxVectsp
      exit repeat
    end if
    spVec = draw(obj, spVec, scale, posH, posV)
  end repeat
  repeat with x = spBit to lastHeighBit
    set the locH of sprite x to -10000
  end repeat
  lastHeighBit = spBit
  repeat with x = spVec to lastHeighVec
    set the locH of sprite x to -10000
  end repeat
  lastHeighVec = spVec
end

on drawBox me, sp, scale, offH, offV
end

on getscale me
  return scale
end

on getcenterPoint me
  t = getrect(me) / 2
  return point(posH + t.width, posV + t.height)
end

on getrect me
  return offset(memRect * scale, posH, posV)
end

on getTargetRect me
  return offset(rescaledRect, posH, posV)
end
