property screenList, unitsize, maxH

on new me
  screenList = []
  maxH = count(screenList)
  maxV = 0
  unitsize = 30
  return me
end

on addnewObj me, posH, posV, obj
  h = reduceInfo(me, posH)
  v = reduceInfo(me, posV)
  addObj(me, h, v, obj)
end

on reduceInfo me, num
  a = integer(num / unitsize) + 1
  return a
end

on deleteLine me, h1, v1, h2, v2, obj
  h1 = reduceInfo(me, h1)
  v1 = reduceInfo(me, v1)
  h2 = reduceInfo(me, h2)
  v2 = reduceInfo(me, v2)
  aList = displayline(h1, v1, h2, v2)
  repeat with x in aList
    h = getAt(x, 1)
    v = getAt(x, 2)
    b = getExistingObj(me, h, v, obj)
    deleteOne(b, obj)
  end repeat
end

on addLine me, h1, v1, h2, v2, obj
  h1 = reduceInfo(me, h1)
  v1 = reduceInfo(me, v1)
  h2 = reduceInfo(me, h2)
  v2 = reduceInfo(me, v2)
  aList = displayline(h1, v1, h2, v2)
  repeat with x in aList
    h = getAt(x, 1)
    v = getAt(x, 2)
    addObj(me, h, v, obj)
  end repeat
end

on addObj me, h, v, obj
  if h > maxH then
    vertList = []
    setAt(vertList, v, [obj])
    setAt(screenList, h, vertList)
    maxH = count(screenList)
  else
    vertList = getAt(screenList, h)
    if not listp(vertList) then
      vertList = []
    end if
    if count(vertList) < v then
      setAt(vertList, v, [obj])
    else
      tempList = getAt(vertList, v)
      if not listp(tempList) then
        setAt(vertList, v, [obj])
      else
        add(tempList, obj)
      end if
    end if
    setAt(screenList, h, vertList)
  end if
end

on getContece me, Arect, filterView
  tempList = [:]
  sort(tempList)
  temprect = (Arect / unitsize) + rect(1, 1, 1, 1)
  repeat with h = temprect.left to temprect.right
    if h < 1 then
      next repeat
    end if
    if h > count(screenList) then
      next repeat
    end if
    Vlist = getAt(screenList, h)
    if not listp(Vlist) then
      next repeat
    end if
    repeat with v = temprect.top to temprect.bottom
      if v < 1 then
        next repeat
      end if
      if v > count(Vlist) then
        next repeat
      end if
      objList = getAt(Vlist, v)
      if not listp(objList) then
        next repeat
      end if
      repeat with obj in objList
        if getPos(tempList, obj) = 0 then
          a = obj.priority
          if a <= filterView then
            addProp(tempList, a, obj)
          end if
        end if
      end repeat
    end repeat
  end repeat
  return tempList
end

on move me, posH, posV, obj, newH, newV
  h = reduceInfo(me, posH)
  v = reduceInfo(me, posV)
  nh = reduceInfo(me, newH)
  nv = reduceInfo(me, newV)
  addObj(me, nh, nv, obj)
  b = getExistingObj(me, h, v, obj)
  deleteOne(b, obj)
end

on delete me, obj
  h = reduceInfo(me, obj.posH)
  v = reduceInfo(me, obj.posV)
  b = getExistingObj(me, h, v, obj)
  deleteOne(b, obj)
end

on getExistingObj me, h, v, obj
  a = getAt(screenList, h)
  b = getAt(a, v)
  return b
end
