global Fcir, Hcir, Qcir, TQcir, radInDeg, degInRad, ginfo

on initUtilities
  Hcir = PI
  Qcir = Hcir / 2
  Fcir = Hcir * 2
  TQcir = Hcir + Qcir
  radInDeg = 360 / (2 * PI)
  degInRad = 2 * PI / 360.0
end

on getRandomRad num
  num = float(num)
  temp = random(num) * Fcir / num
  return temp
end

on convertAngtoDeg num
  return radInDeg * num
end

on convertAng num
  return degInRad * num
end

on loopang ang
  if ang < 0 then
    ang = ang + Fcir
  else
    if ang > Fcir then
      ang = ang - Fcir
    end if
  end if
  return ang
end

on findMotion ang, speedH, speedV
  h = cos(ang) * speedH
  v = sin(ang) * speedV
  return [h, v]
end

on findAngleH a, b
  h = a.posH
  v = a.posV
  nh = b.posH
  nv = b.posV
  return findAngle(h, v, nh, nv)
end

on findAngleZ a, b
  h = a.posH
  v = a.posV
  nh = b.posH
  nv = b.posV
  return findAngle(h, v, nh, nv)
end

on findAngle h, v, nh, nv
  adj = float(nh - h)
  if adj = 0.0 then
    adj = 0.01
  end if
  opp = float(nv - v)
  if opp = 0.0 then
    opp = 0.01
  end if
  x = atan(opp / adj)
  if adj > 0 then
    if opp > 0 then
      return x
    else
      return Fcir + x
    end if
  else
    return Hcir + x
  end if
end

on getdist a, b
  h = a.posH
  v = a.posV
  nh = b.posH
  nv = b.posV
  return getDistNum(h, v, nh, nv)
end

on getDistNum h, v, nh, nv
  a = abs(h - nh)
  b = abs(v - nv)
  c = sqrt((a * a) + (b * b))
  return float(c)
end

on getNum aName
  counter = 0
  repeat with x = 1 to the number of castLibs
    repeat with y = 1 to the number of castMembers of castLib x
      if member(y, x).type = #bitmap then
        if member(y, x).name = aName then
          counter = counter + 1
        end if
      end if
    end repeat
  end repeat
  return counter
end

on stripextension nem
  t = the itemDelimiter
  the itemDelimiter = "."
  g = item 1 of nem
  the itemDelimiter = t
  return g
end

on ChangeExtention aName, extension
  if the number of chars in extension > 4 then
    return 0
  end if
  if the number of chars in extension < 3 then
    return 0
  end if
  if the number of chars in extension < 4 then
    extension = "." & extension
  end if
  if aName contains "." then
    temp = char 1 to offset(".", aName) - 1 of aName
    return temp & extension
  else
    return aName & extension
  end if
end

on getUniqueID
  return random(the maxinteger)
end

on checkforprop obj, aprop
  temp = getaProp(obj, aprop)
  if voidp(temp) then
    obj = getaProp(obj, #ancestor)
    if objectp(obj) then
      return checkforprop(obj, aprop)
    end if
  else
    return temp
  end if
  return 0
end

on SetTheProp obj, aprop, newval
  temp = getaProp(obj, aprop)
  if voidp(temp) then
    obj = getaProp(obj, #ancestor)
    if objectp(obj) then
      return SetTheProp(obj, aprop, newval)
    end if
  else
    setaProp(obj, aprop, newval)
    return temp
  end if
  return 0
end

on makeWebpath v
  repeat with x = 1 to the number of chars in v
    if char x of v = ":" then
      put "/" into char x of v
    end if
    if char x of v = "\" then
      put "/" into char x of v
    end if
  end repeat
  return v
end

on saveFile astring
  fileObj = new(xtra("fileio"))
  answer = displaySave(fileObj, "save your position", "saveList")
  createFile(fileObj, answer)
  openFile(fileObj, answer, 0)
  writeString(fileObj, astring)
  setFinderInfo(fileObj, "TEXT ttxt")
  closeFile(fileObj)
  fileObj = 0
end

on readFile
  fileObj = new(xtra("fileio"))
  answer = displayOpen(fileObj)
  openFile(fileObj, answer, 1)
  temp = readFile(fileObj)
  closeFile(fileObj)
  fileObj = 0
  return temp
end
