property saveList, mem, posH, posV, memRect, rescaledRect, mode, memberName, uniqueID, localAng
global world

on new me, aList, viewObj
  me.memberName = "mouseParent"
  setMouseMode(me, #select)
  Arect = member(mem).rect / 2
  memRect = offset(member(mem).rect, -Arect.width, -Arect.height)
  saveList = [#posH, #posV, #uniqueID]
  if listp(aList) then
    me.uniqueID = getaProp(aList, #uniqueID)
    if voidp(me.uniqueID) then
      uniqueID = getUniqueID()
    end if
    me.posH = getaProp(aList, #posH)
    me.posV = getaProp(aList, #posV)
    changeScale(me, viewObj)
  else
    uniqueID = getUniqueID()
    posH = the mouseH
    posV = the mouseV
  end if
  return me
end

on update me, viewObj
  localAng = viewObj.ang
  tempH = viewObj.posH + (the mouseH * viewObj.scale)
  tempV = viewObj.posV + (the mouseV * viewObj.scale)
  if tempH < 1 then
    tempH = 1
  end if
  if tempV < 1 then
    tempV = 1
  end if
  if tempH >= world.worldSizeH then
    tempH = world.worldSizeH
  end if
  if tempV >= world.worldSizeV then
    tempV = world.worldSizeV
  end if
  posH = tempH
  posV = tempV
end

on changeScale me, viewObj
  rescaledRect = memRect * viewObj.scale
end

on draw me, sp, scale, offH, offV
  set the member of sprite sp to mem
  memRect = member(mem).rect
  p = point(posH, posV) - point(offH, offV)
  ps = p / scale
  set the rect of sprite sp to rect(ps, ps) + memRect
  return sp + 1
end

on getMouseH me
  return posH
end

on getMouseV me
  return posV
end

on getrect me
  return offset(rescaledRect, posH, posV)
end

on touching me
  setMouseMode(me, #touching)
end

on clicked me
  setMouseMode(me, #clicked)
end

on setMouseMode me, amode
  case amode of
    #zoomin:
      me.mode = #zoomin
      me.mem = member(string(#zoomin))
    #zoomOut:
      me.mode = #zoomOut
      me.mem = member(string(#zoomOut))
    #scroll:
      me.mode = #scroll
      mem = member(the number of member "scroll" + integer(localAng * 5))
    #select:
      me.mode = #select
      me.mem = member(string(#select))
    #touching:
      me.mode = #select
      me.mem = member(string(#touching))
    #clicked:
      me.mode = #clicked
      me.mem = member(string(#clicked))
  end case
end
